"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Panel = Panel;

var React = _interopRequireWildcard(require("react"));

var _queryString = _interopRequireDefault(require("query-string"));

var _api = require("@storybook/api");

var _theming = require("@storybook/theming");

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ABSTRACT_APP_URL = process.env.STORYBOOK_ABSTRACT_APP_URL || "https://app.abstract.com";

var Iframe = _theming.styled.iframe({
  width: "100%",
  height: "100%",
  border: "0 none"
});

function parseShareURL(url) {
  if (url.match(/share.(?:go)?abstract.com\//)) {
    var parsedUrl = new URL(url);
    var pathSegments = parsedUrl.pathname.split('/');
    return pathSegments[pathSegments.length - 1];
  }

  throw new Error("The provided url (".concat(url, ") is not valid. The url must come from \"https://share.abstract.com/\" or \"https://share.goabstract.com/\"."));
}

function Panel() {
  var _useStorybookState = (0, _api.useStorybookState)(),
      storyId = _useStorybookState.storyId;

  var params = (0, _api.useParameter)(_constants.PARAM_KEY); // Ignore stories without abstract parameters

  if (!params) return null;

  var _params$options = params.options,
      options = _params$options === void 0 ? {} : _params$options,
      shareDescriptor = _objectWithoutProperties(params, ["options"]);

  return React.useMemo(function () {
    var shareId;

    if ("url" in shareDescriptor) {
      shareId = parseShareURL(shareDescriptor.url);
    } else if ("shareId" in shareDescriptor) {
      shareId = shareDescriptor.shareId;
    }

    if (!shareId) {
      throw new Error("Could not infer share id from ShareDescriptor: \"".concat(JSON.stringify(shareDescriptor), "\""));
    }

    var url = new URL("/embed/".concat(shareId), ABSTRACT_APP_URL);
    url.search = _queryString["default"].stringify(options);
    return /*#__PURE__*/React.createElement(Iframe, {
      src: url.toString()
    });
  }, [shareDescriptor, storyId]);
}